dsdpdsmat.h File Reference

The interface between the SDPCone and the Delta S matrix. More...

Go to the source code of this file.

## Data Structures

struct | DSDPDSMat_C
| Symmetric Delta S matrix for one block in the semidefinite cone. More...

## Typedefs

typedef struct DSDPDSMat_C | DSDPDSMat
| A symmetric Delta S matrix for one block in the semidefinite cone.

## Functions

int | DSDPDSMatDestroy (DSDPDSMat *)
| Free the data structure.
int | DSDPDSMatGetSize (DSDPDSMat, int *)
| Set the opaque pointer and function pointers to the matrix.
int | DSDPDSMatInitialize (DSDPDSMat *)
| Set pointers to null.
int | DSDPDSMatMult (DSDPDSMat, SDPConeVec, SDPConeVec)
| Set values into the matrix.
int | DSDPDSMatSetArray (DSDPDSMat, DSDPVMat)
| Set values into the matrix.
int | DSDPDSMatSetData (DSDPDSMat *, struct DSDPDSMat_Ops *, void *)
| Set the opaque pointer and function pointers to the matrix.
int | DSDPDSMatVecVec (DSDPDSMat, SDPConeVec, double *)
| Compute the product x' A x.
int | DSDPDSMatView (DSDPDSMat)
| Print the matrix.
int | DSDPDSMatZeroEntries (DSDPDSMat)
| Zero the entries in the matrix.

## Detailed Description

The interface between the SDPCone and the Delta S matrix.

Definition in file dsdpdsmat.h.

## Typedef Documentation

## DSDPDSMat

typedef struct DSDPDSMat_C DSDPDSMat

A symmetric Delta S matrix for one block in the semidefinite cone.

typedef struct DSDPDSMat_C DSDPDSMat;

Definition at line 33 of file dsdpdsmat.h.

## Function Documentation

## DSDPDSMatDestroy()

int DSDPDSMatDestroy | ( | DSDPDSMat * | A | ) |

extern

Free the data structure.

Parameters

  A | symmetric DS matrix

Definition at line 70 of file dsdpdsmat.c.

Referenced by DSDPBlockTakeDown().

## DSDPDSMatGetSize()

int DSDPDSMatGetSize | ( | DSDPDSMat | A,
|  | int * | n
| ) |  |

extern

Set the opaque pointer and function pointers to the matrix.

Parameters

  A | symmetric DS matrix
  n | dimension

Definition at line 50 of file dsdpdsmat.c.

## DSDPDSMatInitialize()

int DSDPDSMatInitialize | ( | DSDPDSMat * | B | ) |

extern

Set pointers to null.

Parameters

  B | pointer to matrix.

Definition at line 254 of file dsdpdsmat.c.

Referenced by DSDPBlockInitialize(), and DSDPDSMatDestroy().

## DSDPDSMatMult()

int DSDPDSMatMult | ( | DSDPDSMat | A,
|  | SDPConeVec | X,
|  | SDPConeVec | Y
| ) |  |

extern

Set values into the matrix.

Parameters

  A | symmetric DS matrix
  X | in vector
  Y | product of A and X

Definition at line 154 of file dsdpdsmat.c.

## DSDPDSMatSetArray()

int DSDPDSMatSetArray | ( | DSDPDSMat | A,
|  | DSDPVMat | T
| ) |  |

extern

Set values into the matrix.

Parameters

  A | symmetric DS matrix
  T | Source of entries in dense format

See also
  DSDPSetFormatType()

Definition at line 130 of file dsdpdsmat.c.

Referenced by SDPConeMultiply().

## DSDPDSMatSetData()

int DSDPDSMatSetData | ( | DSDPDSMat * | M,
|  | struct DSDPDSMat_Ops * | ops,
|  | void * | data
| ) |  |

extern

Set the opaque pointer and function pointers to the matrix.

Parameters

  M | symmetric DS matrix
  ops | pointer to a structure of function pointers
  data | pointer to a matrix structure

Definition at line 31 of file dsdpdsmat.c.

Referenced by DSDPDSMatInitialize().

## DSDPDSMatVecVec()

int DSDPDSMatVecVec | ( | DSDPDSMat | A,
|  | SDPConeVec | X,
|  | double * | vAv
| ) |  |

extern

Compute the product x' A x.

Parameters

  A | symmetric DS matrix
  X | vector
  vAv | the product

Definition at line 181 of file dsdpdsmat.c.

Referenced by SDPConeMultiply().

## DSDPDSMatView()

int DSDPDSMatView | ( | DSDPDSMat | A | ) |

extern

Print the matrix.

Parameters

  A | symmetric DS matrix

Definition at line 92 of file dsdpdsmat.c.

## DSDPDSMatZeroEntries()

int DSDPDSMatZeroEntries | ( | DSDPDSMat | A | ) |

extern

Zero the entries in the matrix.

Parameters

  A | symmetric DS matrix

Definition at line 110 of file dsdpdsmat.c.